dnl $Header: //guest/Jon_Parise/api/php/config.m4#3 $
dnl vim: expandtab

PHP_ARG_WITH(perforce, whether to enable Perforce client functions,
[  --with-perforce[=DIR]   Enable support for Perforce client functions])

if test "$PHP_PERFORCE" != "no"; then
  if test -r "$PHP_PERFORCE"; then
     P4API_DIR=$PHP_PERFORCE;
  else
     P4API_DIR=p4api
  fi

  AC_MSG_CHECKING(for Perforce client API in $P4API_DIR)
  if test -r $P4API_DIR/clientapi.h; then
     AC_MSG_RESULT(found)
  else
     AC_MSG_ERROR(Please specify the path to the Perforce client API)
  fi

  AC_DEFINE(HAVE_PERFORCE,1,[ ])
  PHP_SUBST(PERFORCE_SHARED_LIBADD)
  PHP_ADD_LIBRARY_WITH_PATH("supp", $P4API_DIR, PERFORCE_SHARED_LIBADD)
  PHP_ADD_LIBRARY_WITH_PATH("rpc", $P4API_DIR, PERFORCE_SHARED_LIBADD)
  PHP_ADD_LIBRARY_WITH_PATH("client", $P4API_DIR, PERFORCE_SHARED_LIBADD)
  PHP_ADD_INCLUDE($P4API_DIR)
  PHP_NEW_EXTENSION(perforce, perforce.cpp, $ext_shared)
  PHP_REQUIRE_CXX

  grep '^RELEASE' $P4API_DIR/Version | sed -e 's/^.* = /#define P4API_RELEASE \"/' -e 's/ ;$/\"/' > $ext_srcdir/p4api_version.h
fi
